TACHYON
[~

pub MCP79410-RTC.fth        ." MCP79410 I2C RTC DRIVER - 130529.1330 " ; \ 247B

( MCP79410 RTC DRIVER )

$DE    == @rtc        \ RTC I2C ADDRESS 

pub RTC! ( byte addr -- )
    I2CSTART @rtc I2C! I2C! I2C! I2CSTOP
    ;
pub RTC@ ( addr -- byte )
    I2CSTART @rtc I2C! I2C! I2CSTART @rtc 1+ I2C! 1 I2C@ I2CSTOP
    ;

TABLE rtcbuf 8 ALLOT

\ Read first 8 timekeeping bytes of RTC into rtcbuf
pub RDRTC
    I2CSTART @rtc I2C! 0 I2C! I2CSTART @rtc 1+ I2C!
    rtcbuf 8 ADO 0 I2C@ I C! LOOP 1 I2C@ DROP
    I2CSTOP
     ;   
\ Write first 8 timekeeping bytes of RTC from rtcbuf
pub WRRTC
    I2CSTART @rtc I2C! 0 I2C!
    rtcbuf 8 ADO I C@ I2C! LOOP
    I2CSTOP
    ;
pub TIME@ ( -- $hhmmss ) \ read time in bcd format
    RDRTC rtcbuf @ $FFFF7F AND 
    ;
pub DATE@ ( -- $yymmdd ) \ read international date in bcd format
    RDRTC rtcbuf 4 + @ $FF1F3F AND
    ;
pub TIME! ( $hh.mm.ss -- ) \ write time in bcd format 
    $2000.0080 OR rtcbuf ! WRRTC
    ;
\ Usage: $130630 DATE! \ set the date to the 30th June 2013
pub DATE! ( $yy.mm.dd -- ) 
    rtcbuf 4 + ! WRRTC
    ;
pub .TIME         TIME@ L>W .BYTE ." :" W>B .BYTE ." :" .BYTE ;
\ Print date in international format YYYY/MM/DD (otherwise 1/12/2013 could be 1st of December or 12th of January) 
pub .DATE        DATE@ L>W ." 20" .BYTE ." /" W>B .BYTE ." /" .BYTE ;        
pub .DT        .DATE SPACE .TIME ;    


]~
END

