keypoll W~
FORGET NETWORK.fth

TACHYON
[~

pub NETWORK.fth        ." WIZNET NETWORK SERVERS 131023.1500 " ;

{ Primarily testing an FTP server using the WIZnet W5200 chip.
The server task is running in the same cog as the Tachyon console through keypoll. 

The FTP works well using Filezilla but other clients have yet to be tested properly.

Although this module works well it is still incomplete so should be used with caution within an application.
}


IFNDEF W5200.fth
CR ." !!!  This module requires W5200.fth drivers for the WIZnet W5200 !!!          "
!!!
}

IFNDEF GETRND
pub GETRND ( max min -- n )
    SWAP OVER - RND 2/ SWAP MOD SWAP +
    ;
}

\ SOCKETS - W5200 has 8 sockets - define 4 of them
0    == TELNET
1    == FTP
2    == FTPDAT
3    == HTTP

\ Diagnostic to echo all LAN emits to the console as well
pub LCEMIT    DUP $100 OR 2* (EMIT) LANEMIT ;
pub LANCON
    ' LANKEY ukey W!
    ' LCEMIT uemit W! 
    ;
pub LANSKT        socket C@++ SWAP C! LAN ;

CREATE CRLF$ $0D | $0A | 00 |

pub ANNOUNCE_CONNECTED    
     CON CR REVERSE ." CONNECT   SOCKET #" socket C@ . PLAIN SPACE .DT TAB
;

pub CONNECTED? ( -- flg )
    sINTS LC@ &CON AND        \ Has CONNECT interrupt been set?
    DUP IF                \ and save result
       OFF ECHO                \ Setup Tachyon to handle command/response
      &CON sINTS LC!            \ reset the connection interrupt
       TXWRITE LW@ @txwr W!        \ W5200 TXWRITE is now readable - buffer it
      ANNOUNCE_CONNECTED        \ Let me know it's connected
    THEN
    ;

pub DISCONNECTED? ( -- flg )
    sINTS LC@ &DISCON AND
    DUP IF
      $FF sINTS LC!
      CON CR REVERSE ."   CLOSING SOCKET #" socket C@ . PLAIN SPACE .DT TAB
      sOPEN sLISTEN
       ON ECHO ON OK
    THEN
     ;


pub ?TELNET
    TELNET SOCKET                                        \ Use the TELNET socket
    CONNECTED?                                            \ New connection?
    IF
      LAN ." WELCOME TO THE TACHYON WIZNET TELNET SESSION!" CR  CON        \ Welcome banner
      RXWRITE LW@ RXREAD LW! sRECV                            \ Reset rx buffer and receive 
     LANSKT                                              \ update socket and switch char I/O to LAN
    THEN
     DISCONNECTED? DROP                                    \ Process disconnection and discard result
    ;


pub .BYTEDEC        >B $0A .NUM ;
pub COMMA            "," EMIT  ;
pub .IPD ( long -- )     DUP #24 SHR .BYTEDEC COMMA DUP 16 SHR .BYTEDEC COMMA DUP 8 SHR .BYTEDEC COMMA .BYTEDEC ;

WORD dataport

#38002 dataport W!        \ Default FTP data port 

\ ftp commands
pub USER
    [COMPILE] \
    ." 331 User admin OK. Password required" CR
    ;
IMMEDIATE

pub PASS
    [COMPILE] \
    ." 230 OK. Current restricted directory is /" CR
    ;
IMMEDIATE

LONG type
pub TYPE 
    GETWORD type 4 CMOVE
    LAN CR ." 200 TYPE is now " type C@ EMIT CR
    ;
IMMEDIATE


pub PORT    \ accept string
     [COMPILE] \
     ;
IMMEDIATE


#30,000     == #ftpmin
#50,000     == #ftpmax

pub GETPAS
     #ftpmax #ftpmin GETRND dataport W!
    ;
\ 227 Entering Passive Mode (192,168,16,106,248,252)
pub PASV
    GETPAS        \ pick a random port in the specified range
    ." 227 Entering Passive Mode (" 
    srcip .IPD COMMA dataport 1+ C@ .BYTEDEC COMMA dataport C@ .BYTEDEC ." )" CR     
    \ Use user programmable port range - 1025 through 5000
    FTPDAT SOCKET sCLOSE TCP dataport W@ PORT! sOPEN sLISTEN ANNOUNCE_CONNECTED
    FTP SOCKET LAN
    ;
IMMEDIATE

pub SYST
    ." 215 Unix Type: L8" CR
    ;
IMMEDIATE
pub FEAT
      autosend C~
    ." 211 Features supported" CR
     ." UTF8" CR
    ." 211 End" autosend C~~ CR
    ;
IMMEDIATE
pub CDUP
     ." 250 Directory successfully changed" CR
    ;
pub CWD ( <name> )
    [COMPILE] \
     ." 250 Directory successfully changed" CR
    ;
IMMEDIATE
pub PWD
    ." 257 " """ EMIT "/" EMIT """ EMIT ."  is your current location" CR
     ;
IMMEDIATE


pub LIST
    ." 150 Here comes the directory listing" CR
    CON CR REVERSE ." LIST REQUEST " PLAIN CR
    FTPDAT SOCKET TXWRITE LW@ @txwr W!                 \ refresh txwrite (treat as new connection)
    LAN .LIST
    #50 ms                                \ simple delay will do - need to test sent status really
      sDISCON sCLOSE sOPEN sLISTEN                
     FTP SOCKET LAN ." 226 Directory send OK" CR 
    ;
IMMEDIATE

\ Transmit up to one complete sector (512 bytes) or less (cnt)
\ 

\ Update TXWRITE and send what we have in the buffer and waiting for completion
pub (SEND)
      @txwr W@ TXWRITE LW!                         \ Update TXWRITE and
      sSEND                                \ SEND transmit buffer
\        BEGIN sINTS LC@ &SENDOK AND UNTIL             \ wait for it to go
\       &SENDOK sINTS LC!                        \ clear the interrupt
;
pri (LSEND) ( src cnt -- )
      TXBASE0 socket C@ #11 SHL +                        \ WIZnet socket TXBUFF address
       @txwr W@ $7FF AND + ( src cnt dst )                \ add in the current txbuffer write index
       SWAP DUP @txwr W+!
     LWRITE ( hsrc wdst cnt -- )                            \ Write the full count - won't wrap around
     ;
pri LSEND ( src cnt -- )
     TXWRITE LW@ $7FF AND OVER + $800 >                \ figure out if there is a wraparound
     IF
       $800 @txwr W@ $7FF AND -                     \ find 1st cnt      
       SWAP OVER - SWAP                         \ adjust cnt for 2nd 
       ( src cnt2 cnt1 )
       ROT ( cnt2 cnt1 src )
        2DUP + ( cnt2 cnt1 src src2 )
       SWAP ROT ( cnt2 src2 src cnt1 )
       (LSEND) SWAP 
    THEN
     (LSEND) (SEND)
    ;


$200 == BUFSIZ
pub BLKSEND ( xaddr cnt -- )                            \ send up to one complete sector at buffer address
     BEGIN
\        BEGIN TXWRITE LW@ TXREAD LW@ = UNTIL                \ Wait for buffer to be released (only using 512 bytes/time)
      OVER XADR OVER BUFSIZ MIN ( xaddr cnt bufadr bufcnt )    \ grab it a chunk at a time
      >L                                         \ save the bufcnt
      @txwr W@ $FFFF = IF TXWRITE LW@ @txwr W! THEN            \ force an update (assumed valid) if the index is "invalid"
       IX LSEND                                    \ copy source buffer to socket tx buffer
       ( src cnt )
      IX - SWAP L> + SWAP ( xaddr cnt )                    \ update source parameters block by block
      DUP 0=                                    \ until the source buffer is exhausted (cnt=0)
     UNTIL
     2DROP 
     ;

 
pub RETR
    GETWORD FOPEN$                                \ get the file name and try to open it
     IF  
       LAN CR ." 150 Accepted data connection" CR
       FTPDAT SOCKET                                 \ Use FTP DATA connection socket
       TXWRITE LW@ @txwr W!                             \ refresh txwrite (treat as new connection)

\ Use a sector block write method to increase efficiency
       LAN FILE@ FSIZE@ BLKSEND
      #200 ms                                    \ test delay
       FTPDAT SOCKET sDISCON sCLOSE sOPEN sLISTEN            \ close the data connection
       FTP SOCKET LAN ." 226 File successfully transferred" CR    \ Announce successful transfer
     ELSE
       LAN ." 550 File not found" CR
     THEN
    ;
IMMEDIATE


pub REST ( <position> )
     GETWORD
     ;
IMMEDIATE


    


pub ?FTP
    FTP SOCKET
    CONNECTED?
    IF
      LAN ." 220 WELCOME TO THE TACHYON WIZNET FTP SESSION!" CR  CON
       OFF OK                                \ disable the Forth "ok" confirmation so FTP can use Forth itself
      RXWRITE LW@ RXREAD LW! sRECV                    
     \  BEGIN KEY? WHILE DROP REPEAT
      LANSKT    
    THEN
    DISCONNECTED? IF FTPDAT SOCKET sDISCON DISCONNECTED? DROP THEN
    ;
                                                            

pub ?HTTP
    HTTP SOCKET CONNECTED?
    IF
        LAN      
       ." <!DOCTYPE html> <html> <body> <h1>My First Heading</h1> <p>My first paragraph.</p> </body> </html>" CR
    THEN
    DISCONNECTED? DROP
    ;


\ 420us idle loop
pub SERVER
    socket C@ socket 1+ C!                    \ swap current socket between foreground and background
    ?TELNET                            \ Poll the TELNET server
    ?FTP                                \ Poll the FTP server
    ?HTTP                                \ Poll the WEB server
    socket 1+ C@ SOCKET                    \ restore foreground socket
    KEY? IF $1B = 
       IF CON keypoll W~ ON ECHO ON OK ." CONSOLE " CR THEN 
     ELSE DROP 
     THEN
    ;    

pub GO
    !SP
    !PCB !WIZIO #100 ms                    \ Setup I2CBUS LEDS (includes WIZNET RESET & PWRDN)
    MOUNT ls
    !WIZIP
{
    &192.168.16.1 GATEWAY                    \ Assign a default gateway
    &255.255.255.0 SUBNET
    &192.168.16.150 SRCIP
    MAC SHAR                            \ dummy MAC, Need to have a unique ID
}
    $8000 $4000 ADO 0 I L! 4 +LOOP            \ clear WIZnet transmit buffers (for diagnostics)
     txwr 16 $FF FILL                        \ invalidate all txwr pointers (W5200 workaround)
    TELNET SOCKET sCLOSE TCP #10001 PORT! sOPEN sLISTEN    \ Setup TELNET
    FTP SOCKET sCLOSE TCP #21 PORT! sOPEN sLISTEN    \ Setup FTP
    HTTP SOCKET sCLOSE TCP #80 PORT! sOPEN sLISTEN    \ Setup HTTP
    ' SERVER keypoll W!                    \ Poll the server in the background
    WIZ?                                \ report WIZnet status 
    ;


{
GO Mounted SD Card
Media mounted as E2C4.0203 mkdosfs PBJTECH     FAT32    Cluster size = 4,096   Sectors = 7,744,512      PBJTECH    
LOG0001 .TXT     LOG0002 .TXT     LOG0003 .TXT     LOG0004 .TXT     LOG0005 .TXT     
LOG0006 .TXT     LOG0007 .TXT     LOG0008 .TXT     LOG0009 .TXT     LOG0010 .TXT     LOG0011 .TXT     LOG0012 .TXT     LOG0013 .TXT  
LOG0014 .TXT     LOG0015 .TXT     LOG0016 .TXT     SYSLOG  .TXT     MCP79410.FTH     EXTEND  .FTH     W5200   .FTH     MULTIFAT.FTH  
SDCARD  .FTH     NETWORK .FTH     
************ W5200 STATUS ************
LINK DOWN
CHIP VER  0003
SRC IP    192.168.016.150.
MASK      255.255.255.000.
GATEWAY   192.168.016.001.
MAC       00.08.29.CE.30.E1.
*** SOCKETS ***
0: MODE= TCP    PORT#10001 0000  TXRW=0000.0000.RXRW=0000.0000.RXSZ=0000.IR=00   STAT=14 LISTEN
1: MODE= TCP    PORT#0021 0000   TXRW=0000.0000.RXRW=0000.0000.RXSZ=0000.IR=00   STAT=14 LISTEN
2: MODE= CLOSED PORT#0000 0000   TXRW=0000.0000.RXRW=0000.0000.RXSZ=0000.IR=00   STAT=00 CLOSED
3: MODE= TCP    PORT#0080 0000   TXRW=0000.0000.RXRW=0000.0000.RXSZ=0000.IR=00   STAT=14 LISTEN
4: MODE= CLOSED PORT#0000 0000   TXRW=0000.0000.RXRW=0000.0000.RXSZ=0000.IR=00   STAT=00 CLOSED
5: MODE= CLOSED PORT#0000 0000   TXRW=0000.0000.RXRW=0000.0000.RXSZ=0000.IR=00   STAT=00 CLOSED
6: MODE= CLOSED PORT#0000 0000   TXRW=0000.0000.RXRW=0000.0000.RXSZ=0000.IR=00   STAT=00 CLOSED
7: MODE= CLOSED PORT#0000 0000   TXRW=0000.0000.RXRW=0000.0000.RXSZ=0000.IR=00   STAT=00 CLOSED
}
\ AUTORUN GO
\ BACKUP

]~
END
\ GO

